/*
 * Copy me if you can.
 * by 20h
 */

#include <u.h>
#include <libc.h>
#include <draw.h>
#include <event.h>

typedef struct gproc gproc;
struct gproc
{
	char *name[2];
	gproc *n;
	gproc *p;
};

Image *textc;
Image *hoverc;
Image *hovertc;
Image *borderc;
Image *backc;
Image *backtc;
Image *scrollc;
Image *sortc;
Image *sorttc;

gproc *glist, *oglist;
int f[3], sel, osel, scr, oscr, view, nall, partd, sortn;
Rectangle scroll;
char flags;

enum
{
	PFLAG = 0x1,
};

char *buttons[] =
{
	"procs",
	"refresh",
	"exit",
	0,
};

char *title[] =
{
	"user",
	"proc",
	0
};

enum {
	PROCS = 0x0,
	REFRESH,
	EXIT
};

Menu menu =
{
	buttons
};

void *
reallocg(void *v, ulong n)
{
	v = realloc(v, n);
	if(v == nil)
		sysfatal("no memory allocable.");

	return v;
}

char *
strdupg(char *s)
{
	char *ret;

	ret = reallocg(nil, strlen(s) + 1);
	strcpy(ret, s);
	ret[strlen(s)] = '\0';

	return ret;
}

void
free_gproc(gproc *gl)
{
	char i;

	if(gl != nil)
	{
		i = -1;
		while(++i < 2)
			if(gl->name[i] != nil)
				free(gl->name[i]);

		free(gl);
	}
	return;
}

void
free_gprocl(gproc *gn)
{
	int n;

	n = -1;

	while(gn != nil)
	{
		if(gn->n != nil)
		{
			gn = gn->n;
			free_gproc(gn->p);
			n++;
		} else {
			free_gproc(gn);
			return;
		}
	}
	return;
}

gproc *
get_num(gproc *t, int n)
{

	while(--n > 0)
		if(t != nil)
			t = t->n;
	return t;
}

int
get_n(gproc *t)
{
	int ret;

	ret = 0;

	while(t->n != nil)
	{
		ret++;
		t = t->n;
	}

	return ret;
}

int
compare(gproc *a, gproc *b)
{
	int i;

	if(a->name[sortn] == nil || b->name[sortn] == nil)
		return -1;

	if(strlen(a->name[sortn]) > strlen(b->name[sortn]))
		return -1;
	if(strlen(a->name[sortn]) < strlen(b->name[sortn]))
		return 1;

	i = -1;
	while((a->name[sortn])[++i] != '\0')
	{
		if((a->name[sortn])[i] < (b->name[sortn])[i])
			return 1;
		if((a->name[sortn])[i] > (b->name[sortn])[i])
			return -1;
	}

	return -1;
}

gproc *
insertsort(gproc *g, short dir)
{
	gproc *s, *n;
	char *t;
	int i;

	if(sortn == -1 || g->n == nil)
		return g;

	s = g;

	while(s->n != nil)
	{
		n = s;
		while(n != nil)
		{
 			if(compare(n->n, n) == dir)
			{
				if(n->n != n)
				{
					i = -1;
					while(++i < 2)
					{
						t = n->name[i];
						n->name[i] = n->n->name[i];
						n->n->name[i] = t;
					}
				}
			}
			n = n->p;
		}

		s = s->n;
	}

	return g;
}

gproc *
search_gprocl(gproc *g, char *s)
{

	while(g != nil)
	{
		if(g->name[0] != nil)
			if(!strcmp(g->name[0], s))
				return g;
		g = g->n;
	}
	return nil;
}

gproc *
get_whodata(void)
{
	gproc *ret, *b, *a, *d;
	Dir *dir;
	int fd, tot, dfd, n;
	char status[178], *c;

	ret = nil;
	b = nil;
	a = nil;

	if(chdir("/proc") < 0)
		return nil;

	fd = open(".", OREAD);
	if(fd < 0)
		return nil;

	tot = dirreadall(fd, &dir);
	if(tot <= 0)
	{
		close(fd);
		return nil;
	}
	close(fd);

	while(--tot >= 0)
	{
		if(b != a)
			free_gproc(a);

		a = reallocg(nil, sizeof(gproc));
		memset(a, 0, sizeof(gproc));
		a->n = nil;
		a->p = nil;

		snprint(status, 177, "%s/status", dir[tot].name);
		dfd = open(status, OREAD);
		if(dfd < 0)
			continue;

		status[177] = '\0';
		n = read(dfd, status, 176);
		if(n < 0)
			continue;
		close(dfd);

		c = strchr(status, ' ');
		if(c == nil)
			continue;
		*c = '\0';
		c = strchr(status + 28, ' ');
		if(c == nil)
			continue;
		*c = '\0';

		if((d = search_gprocl(ret, status + 28)))
		{
			if(d->name[1] == nil)
			{
				d->name[1] = reallocg(nil, 12);
				snprint(d->name[1], 12, "1");
			} else {
				snprint(d->name[1], 12, "%d", atoi(d->name[1]) + 1);
			}
			continue;
		}

		a->name[0] = strdupg(status + 28);
		a->name[1] = reallocg(nil, 12);
		snprint(a->name[1], 12, "1");

		if(b != nil)
			b->n = a;
		a->p = b;

		b = a;
		if(ret == nil)
			ret = a;
	}
	free(dir);

	ret = insertsort(ret, -1);

	return ret;
}

void
draw_scrollbar(Rectangle r)
{

	partd = Dy(r) / (nall + 1);

	draw(screen, r, scrollc, nil, ZP);
	if((scr + view) * partd <= Dy(r))
	{
		draw(screen, Rect(r.min.x, r.min.y + partd * scr, r.max.x, r.min.y + partd * (scr + view)), backc, nil, ZP);
	} else {
		draw(screen, Rect(r.min.x, r.min.y + partd * scr, r.max.x, r.max.y), backc, nil, ZP);
	}

	return;
}

void
draw_who(int g)
{
	int d, e;
	gproc *n, *no;
	Point max;
	char *a;

	if(g > 0)
	{
		if(glist != nil)
		{
			if(oglist != nil)
				free_gprocl(oglist);
			oglist = glist;
		}

		glist = get_whodata();
	}

	e = (screen->r.max.x - screen->r.min.x - 15) / 2;

	if(g > 3)
		draw(screen, screen->r, backc, nil, ZP);

	max = screen->r.max;
	max.y--;
	max.x--;

	d = screen->r.min.x;

	if(g > 3)
	{
		line(screen, (Point){d, screen->r.min.y}, (Point){max.x, screen->r.min.y}, 0, 0, 0, borderc, ZP);
		line(screen, (Point){max.x, screen->r.min.y}, max, 0, 0, 0, borderc, ZP);
		line(screen, max, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
		line(screen, (Point){d, max.y}, (Point){d, screen->r.min.y}, 0, 0, 0, borderc, ZP);
	}

	f[0] = screen->r.min.x + 12;
	f[2] = max.x;
	d += 12;
	scroll = Rect(screen->r.min.x + 1, screen->r.min.y + 3 + font->height, d, screen->r.max.y - 1);
	if(g > 3)
	{
		draw(screen, Rect(screen->r.min.x + 1, screen->r.min.y + 1, d, screen->r.min.y + 2 + font->height), borderc, nil, ZP);
		draw(screen, Rect(screen->r.min.x + 2, screen->r.min.y + 2, d - 1, screen->r.min.y + 1 + font->height), backtc, nil, ZP);
		line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
	}

	d += e;
	f[1] = d;
	if(g > 3 && flags & PFLAG)
		line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
	if(!(flags & PFLAG))
		f[1] = f[2];

	if(g > 3)
		line(screen, (Point){screen->r.min.x, screen->r.min.y + font->height + 2}, (Point){max.x, screen->r.min.y + font->height + 2}, 0, 0, 0, borderc, ZP);

	if(g > 2)
	{
		e = -1;
		while(title[++e] != 0)
		{
			if(!(flags & PFLAG))
				if(e == 1)
					continue;

			draw(screen, Rect(f[e] + 1, screen->r.min.y + 1, f[e + 1], screen->r.min.y + 2 + font->height), (e == sortn) ? sortc : backtc, nil, ZP);

			a = strdupg(title[e]);
			if(stringwidth(font, a) >= f[e + 1] - f[e])
				a[strlen(a) - ((stringwidth(font, a) - f[e + 1] + f[e] + 2) / (stringwidth(font, a) / strlen(a)) + 1)] = '\0';
			string(screen, (Point){f[e] + (f[e + 1] - f[e]) / 2 - stringwidth(font, a) / 2, screen->r.min.y + 1}, (e == sortn) ? sorttc : textc, ZP, font, a);
			free(a);
		}
	}

	d = 0;
	n = get_num(glist, scr);
	no = get_num(oglist, scr);
	while(n != nil && ((d + 2) * font->height + 3) < Dy(screen->r))
	{
		d++;
		e = -1;
		while(++e < 2)
		{
			if(!(flags & PFLAG))
				if(e == 1)
					continue;

			if(no != nil && g < 1 && d != sel && d != osel)
				if(!strcmp(no->name[e], n->name[e]))
					goto items_none;

			draw(screen, Rect(f[e] + 1, screen->r.min.y + 3 + font->height * d, f[e + 1], screen->r.min.y + 3 + font->height * (d + 1)), (d == sel) ? hoverc : backc, nil, ZP);

			if(n->name[e] != nil)
			{
				if(stringwidth(font, n->name[e]) >= f[e + 1] - f[e])
					(n->name[e])[strlen(n->name[e]) - ((stringwidth(font, n->name[e]) - f[e + 1] + f[e]) / (stringwidth(font, n->name[e]) / strlen(n->name[e])) + 1)] = '\0';
				string(screen, (Point){f[e] + 2, screen->r.min.y + 3 + font->height * d}, (d == sel) ? hovertc : textc, ZP, font, n->name[e]);
			}
		}
items_none:
		if(no != nil)
			no = no->n;
		n = n->n;
	}

	while(((d + 2) * font->height + 3) < Dy(screen->r))
	{
		d++;
		e = -1;
		while(++e < 2)
		{
			if(!(flags & PFLAG))
				if(e == 1)
					continue;
			draw(screen, Rect(f[e] + 1, screen->r.min.y + 3 + font->height * d, f[e + 1], screen->r.min.y + 3 + font->height * (d + 1)), backc, nil, ZP);
		}
	}

	if(g > 1)
		view = d;
	nall = get_n(glist);

	draw_scrollbar(scroll);

	return;
}

void
eresized(int new)
{

	if(new && getwindow(display, Refnone) < 0)
		sysfatal("can't reattach to window");

	draw_who(4);

	return;
}

void
usage(void)
{

	print("usage: gwho [-p] [-s sec]\n");
	return;
}

void
main(int argc, char *argv[])
{
	int sec, Etimer, fd;
	Event e;

	sec = 2;
	scr = 0;
	sel = -1;
	sortn = -1;
	flags = '\0';

	if(initdraw(nil, nil, "gwho") < 0)
		sysfatal("initdraw failed: %r");

	ARGBEGIN {
		case 's':
			sec = atoi(ARGF());
			break;
		case 'p':
			flags |= PFLAG;
			break;
		default:
			usage();
			exits(0);
	} ARGEND;

	backc = allocimagemix(display, DPaleyellow, DWhite);
	if(backc == nil)
		sysfatal("allocimagemix: %r");
	textc = allocimagemix(display, DBlack, DBlack);
	if(textc == nil)
		sysfatal("allocimagemix: %r");
	hoverc = allocimagemix(display, DDarkyellow, DDarkyellow);
	if(hoverc == nil)
		sysfatal("allocimagemix: %r");
	borderc = allocimagemix(display, DPurpleblue, DPurpleblue);
	if(borderc == nil)
		sysfatal("allocimagemix: %r");
	hovertc = allocimagemix(display, DBlack, DBlack);
	if(hovertc == nil)
		sysfatal("allocimagemix: %r");
	backtc = allocimagemix(display, DPalebluegreen, DWhite);
	if(backtc == nil)
		sysfatal("allocimagemix: %r");
	scrollc = allocimagemix(display, DPurpleblue, DPurpleblue);
	if(scrollc == nil)
		sysfatal("allocimagemix: %r");
	sortc = allocimagemix(display, DDarkyellow, DDarkyellow);
	if(sortc == nil)
		sysfatal("allocimagemix: %r");
	sorttc = allocimagemix(display, DBlack, DBlack);
	if(sorttc == nil)
		sysfatal("allocimagemix: %r");

	eresized(0);

	einit(Emouse);
	Etimer = etimer(0, sec * 1000);

	while(1)
	{
		switch(eread(Emouse|Etimer, &e))
		{
			case Emouse:
				if(e.mouse.buttons & 1)
				{
					if(e.mouse.xy.y < screen->r.min.y + font->height + 2)
					{
						fd = -1;
						while(++fd < 2)
						{
							if(!(flags & PFLAG))
								if(fd == 1)
									continue;
							if(e.mouse.xy.x < f[fd + 1] && e.mouse.xy.x >= f[fd])
							{
								if(sortn == fd)
								{
									sortn = -1;
								} else {
									sortn = fd;
								}
								draw_who(3);
								break;
							}
						}
						break;
					}
					if(e.mouse.xy.x < screen->r.min.x + 15)
					{
						if((scr - view / 2) <= 0)
						{
							scr = 0;
						} else {
							scr -= view / 2;
						}

						draw_who(2);
					} else {
						osel = sel;
						fd = (e.mouse.xy.y - screen->r.min.y - 1) / font->height;
						if(fd == sel)
						{
							sel = 0;
						} else {
							sel = fd;
						}

						draw_who(0);
					}
					break;
				}
				if(e.mouse.buttons & 2)
				{
					if(e.mouse.xy.x < screen->r.min.x + 15 && e.mouse.xy.y > screen->r.min.y + font->height + 2)
					{
						scr = (e.mouse.xy.y - scroll.min.y) / partd;
						draw_who(2);
					}
					break;
				}
				if(e.mouse.buttons & 4)
				{
					if(e.mouse.xy.x < screen->r.min.x + 15 && e.mouse.xy.y > screen->r.min.y + font->height + 2)
					{
						scr += view / 2;
						draw_who(2);
						break;
					}
					switch(emenuhit(3, &e.mouse, &menu))
					{
						case PROCS:
							flags ^= PFLAG;
							draw_who(4);
							break;
						case REFRESH:
							draw_who(1);
							break;
						case EXIT:
							goto free_all;
						default:
							break;
					}
				}
				break;
			default:
				draw_who(1);
				break;
		}
		sleep(1);
	}

free_all:

	freeimage(textc);
	freeimage(hoverc);
	freeimage(backc);
	freeimage(hovertc);
	freeimage(borderc);
	freeimage(backtc);
	freeimage(scrollc);
	freeimage(sortc);
	freeimage(sorttc);

	if(glist != nil)
		free_gprocl(glist);
	if(oglist != nil)
		free_gprocl(oglist);

	exits(0);
}
